"""
w2lconnect.py: present connect dialogue for choosing server

web2ldap - a web-based LDAP Client,
see http://www.web2ldap.de for details

(c) by Michael Stroeder <michael@stroeder.com>
Distributed under GNU Public License (GPL)
"""

# Modules shipped with web2ldap
import web2ldapcnf
import cgiforms,w2lcore,w2lgui

##############################################################################
# Connect form
##############################################################################

def w2l_Connect(outf,command,form,ls,host=None,Msg='New connect'):

  w2lgui.PrintHeader(outf,'Connect',form.accept_charset)

  host_select_list = []
  for host in web2ldapcnf.ldap_host_list:
    host_desc = web2ldapcnf.hosts.ldap_def.get(host,{}).get('description','')
    if host_desc:
      host_str = '%s (%s)' % (host,host_desc)
    else:
      host_str = host
    host_select_list.append(
      (
	unicode(host,'iso-8859-1'),
	unicode(host_str,'iso-8859-1')
      )
    )
  if host is None and hasattr(ls,'host'):
    host = ls.host
  elif host_select_list:
    host = host_select_list[0]
  host_select_field = cgiforms.formSelectClass('host',u'LDAP Host',host_select_list,default=host)

  outf.write("""
<div id="InputDiv">

  <h1>%s</h1>

  <form 
    action="%s/searchform"
    method="%s" 
    enctype="application/x-www-form-urlencoded"
    accept-charset="%s"
  >
    <h2>Pre-configured LDAP host(s)</h2>
    <p>Choose a LDAP server from select list.</p>
    <fieldset title="Any LDAP host by name:port and a search root">
      <input type="submit" value="Connect to">%s
    </fieldset>
  </form>

  <form 
    action="%s/searchform"
    method="%s" 
    enctype="application/x-www-form-urlencoded"
    accept-charset="%s"
  >
    <h2>Access any LDAP host</h2>
    <fieldset title="Any LDAP host by name:port and a search root">
      <input type="submit" value="Connect to">
      <table summary="Host parameters">
        <tr>
          <td>to host:port</td>
          <td>%s</td>
        </tr>
        <tr>
          <td>search root<br />(optional)</td>
          <td>%s</td>
        </tr>
      </table>
    </fieldset>
  </form>

  <form 
    action="%s/locate"
    method="%s" 
    enctype="application/x-www-form-urlencoded"
    accept-charset="%s"
  >
    <h2>Locate LDAP host via DNS</h2>
    <p>
      Search for well-known DNS aliases
      of LDAP servers and DNS SRV records in
      a given DNS domain (experimental).
    </p>
    <fieldset title="Locate LDAP host by DNS name or DN.">
      <input type="submit" value="Locate"><br />
      <table>
        <tr>
          <td width="30%%">
            E-mail address, DNS domain or dc-style DN:
          </td>
          <td>
            <input name="locate_name" size="30">
          </td>
        </tr>
      </table>
    </fieldset>
  </form>

</div>

""" % (
    Msg,
    form.script_name,
    web2ldapcnf.script_method,
    form.accept_charset,
    host_select_field.inputfield(),
    form.script_name,
    web2ldapcnf.script_method,
    form.accept_charset,
    form.field['host'][0].inputfield(),
    form.field['dn'][0].inputfield(),
    form.script_name,
    web2ldapcnf.script_method,
    form.accept_charset,
  )
)

  w2lgui.PrintFooter(outf)
