"""
w2ldelete.py: delete an entry

web2ldap - a web-based LDAP Client,
see http://www.web2ldap.de for details

(c) by Michael Stroeder <michael@stroeder.com>
Distributed under GNU Public License (GPL)
"""

import sys,cgiforms, ldap, ldapbase, w2lcore, web2ldapcnf, w2lcnf, w2lgui
from ldapbase import ParentDN

########################################################################
# Delete entry
########################################################################

def w2l_Delete(sid,outf,command,form,ls):

  if 'delete_confirm' in form.inputkeys:

    if form.field['delete_confirm'][0].content=='yes':

      # Recursive delete of whole sub-tree

      if ('delete_recursive' in form.inputkeys) and \
         form.field['delete_recursive'][0].content=='yes':

        def DelTree(outf,form,ls,ContinueErrorExit,dn,continueonerror=0):
          dellist = ldapbase.SearchTree(ls.l,dn,attrsonly=w2lcnf.GetParam(ls,'search_attrsonly',1),timeout=w2lcnf.GetParam(ls,'timeout','4'))
	  dellist.reverse()
          for dn in dellist:
            ls.deleteEntry(dn)

        continue_on_error = ('delete_coe' in form.inputkeys) and \
                            form.field['delete_coe'][0].content=='yes'

	DelTree(outf,form,ls,continue_on_error,ls.dn,continue_on_error)
	w2lgui.PrintHeader(outf,'Delete tree',form.accept_charset)
        old_dn = ls.dn
        ls.setDN(ParentDN(ls.dn))
	w2lgui.MainMenuTable(sid,outf,form,ls)
        outf.write('<div id="MessageDiv"><p>Deleted entries below %s.</p></div>' % (
            w2lgui.DisplayDN(sid,form,ls,old_dn)
          )
        )

      else:

        ls.deleteEntry(ls.dn)

	w2lgui.PrintHeader(outf,'Deleted Entry',form.accept_charset)
        old_dn = ls.dn
        ls.setDN(ParentDN(ls.dn))
	w2lgui.MainMenuTable(sid,outf,form,ls)
        outf.write('<div id="MessageDiv"><p>Deleted entry %s.</p></div>' % (
            w2lgui.DisplayDN(sid,form,ls,old_dn)
          )
        )

      w2lgui.PrintFooter(outf)

    else:
      raise w2lcore.ErrorExitClass(ls,'Canceled delete.')

  else:

    # Print confirmation form
    w2lgui.PrintHeader(outf,'Delete entry?',form.accept_charset)
    w2lgui.MainMenuTable(sid,outf,form,ls)
    outf.write("""<div id=MessageDiv>
<form action="%s/delete"
      method="POST"
      enctype="application/x-www-form-urlencoded"
      accept-charset="%s"
>
  <input type="hidden" name="sid" value="%s">
  <p>Delete %s. Are you sure?</p>
  <p>
    %s Recursive delete of all sub-entries.
    <strong>Use with care! Might take some time.</strong><br>
    %s Continue on error (affects only recursive delete).
  </p>
  <input name="delete_confirm" type="submit" value="yes">
  <input name="delete_confirm" type="submit" value="no">
</form>
</div>
""" % (
      form.script_name,
      form.accept_charset,
      sid,
      w2lgui.DisplayDN(sid,form,ls,ls.dn),
      form.field['delete_recursive'][0].inputfield(),
      form.field['delete_coe'][0].inputfield()
    ))
    w2lgui.PrintFooter(outf)

