"""
w2llogin.py: bind with a specific bind DN and password

web2ldap - a web-based LDAP Client,
see http://www.web2ldap.de for details

(c) by Michael Stroeder <michael@stroeder.com>
Distributed under GNU Public License (GPL)
"""

import sys,string,web2ldapcnf

# Modules shipped with web2ldap
import cgiforms,ldapbase,cgiforms,w2lcore,w2lgui,w2lcnf

##############################################################################
# Login form
##############################################################################

def w2l_Login(
  sid,outf,command,form,ls,title_msg='',login_msg='',who='',relogin=0,nomenu=0
):
  """
  Provide a input form for doing a (re-)login
  """
  if 'login_who' in form.inputkeys:
    who = form.field['login_who'][0].content

  w2lgui.PrintHeader(outf,login_msg,form.accept_charset)
  if not nomenu:
    w2lgui.MainMenuTable(sid,outf,form,ls)
  outf.write("""
<div id=ErrorMessageDiv>
  <h1>%s</h1>
  <p>%s</p>
  <form
    id=CommandForm
    action="%s/%s"
    method="POST"
    enctype="application/x-www-form-urlencoded"
    accept-charset="%s"
  >
    <input type="hidden" name="sid" value="%s">
    <input type="hidden" name="host" value="%s">
    <input type="hidden" name="dn" value="%s">
    <p>
      <input type="submit" value="%s">
    </p>
    %s
    <p>
      to host:port %s (%s)
      with smart login searches below %s.
    </p>
"""  % (
      title_msg,
      login_msg,
      form.script_name,
      command,
      form.accept_charset,
      sid,
      ls.host.encode('ascii'),
      ls.dn.encode(form.accept_charset),
      {0:'Login',1:'Retry'}[relogin],
      w2lgui.BindInput % who.encode(form.accept_charset),
      ls.host.encode('ascii'),
      w2lcore.iso2display(
        form.accept_charset,
        web2ldapcnf.hosts.ldap_def.get(ls.host,{}).get('description','')
      ),
      w2lgui.DisplayDN(sid,form,ls,ls.searchRoot),
    )
  )
  if relogin:
    form.hiddeninputparams(outf,['sid','host','dn','who','cred'])
  outf.write('</form>\n</div>')
  w2lgui.PrintFooter(outf)


