"""
w2lmodrdn.py: change RDN of an entry

web2ldap - a web-based LDAP Client,
see http://www.web2ldap.de for details

(c) by Michael Stroeder <michael@stroeder.com>
Distributed under GNU Public License (GPL)
"""

import sys,cgiforms,ldap,ldapbase,w2lcore,web2ldapcnf,w2lgui

########################################################################
# Modify RDN
########################################################################

def w2l_ModRDN(sid,outf,command,form,ls):

  if not ls.dn:
    raise w2lcore.ErrorExitClass(ls,'ModRDN not possible at - World - or RootDSE.')
    
  if 'modrdn_newrdn' in form.inputkeys:

    modrdn_newrdn = form.field['modrdn_newrdn'][0].content
    if 'modrdn_delold' in form.inputkeys:
      modrdn_delold = form.field['modrdn_delold'][0].content=='yes'
    else:
      modrdn_delold = 0

    # Modify the RDN
    ls.modRDN(
      ls.dn,modrdn_newrdn,modrdn_delold
    )
    old_dn = ls.dn
    new_dn = '%s,%s' % (modrdn_newrdn,w2lcore.ParentDN(ls.dn))
    ls.setDN(new_dn)

    w2lgui.PrintHeader(outf,'Modified DN of entry.',form.accept_charset)
    w2lgui.MainMenuTable(sid,outf,form,ls)
    outf.write("""
      <div id=MessageDiv>
        <p>
          Modified dn of entry <strong>%s</strong> to <strong>%s</strong>.
        </p>
      </div>
      """ % (
        w2lgui.DisplayDN(sid,form,ls,old_dn),
        w2lgui.DisplayDN(sid,form,ls,new_dn)
      )
    )
    w2lgui.PrintFooter(outf)

  else:
    form.field['modrdn_newrdn'][0].setdefault(w2lcore.utf2display(form.accept_charset,ldapbase.SplitRDN(ls.dn)[0]))
    # Leeres Eingabeformular fr neuen RDN ausgeben
    w2lgui.PrintHeader(outf,'Modify RDN',form.accept_charset)
    w2lgui.MainMenuTable(sid,outf,form,ls)
    outf.write("""
<div id=InputDiv>
<h1>Modify RDN</h1>
<form action="%s/modrdn"
      method="POST"
      enctype="application/x-www-form-urlencoded"
      accept-charset="%s"
>
  <input type="hidden" name="sid" value="%s">
  <table>
    <tr><td>%s</td><td>%s</td></tr>
    <tr><td>%s</td><td>%s</td></tr>
  </table>
  <input type="submit" value="Change RDN">
  <input type="reset" value="Reset">
</form>
</div>
""" % (
      form.script_name,
      form.accept_charset,
      sid,
      form.field['modrdn_newrdn'][0].text.encode(form.accept_charset),
      form.field['modrdn_newrdn'][0].inputfield(),
      form.field['modrdn_delold'][0].text.encode(form.accept_charset),
      form.field['modrdn_delold'][0].inputfield()
    ))
    w2lgui.PrintFooter(outf)


