"""
w2lsecinfo.py: Display (SSL) connection data

web2ldap - a web-based LDAP Client,
see http://www.web2ldap.de for details

(c) by Michael Stroeder <michael@stroeder.com>
Distributed under GNU Public License (GPL)
"""

import time,threading,ldap,utctime,web2ldapcnf,w2lcore,w2lgui,w2lcnf

from cgiforms import escapeHTML


def w2l_Monitor(outf,command,form):
  """
  List several general gateway stats
  """
  w2lgui.PrintHeader(outf,'Gateway Monitor',form.accept_charset)
  
  uptime = (time.time()-w2lcore.startUpTime)/60

  outf.write("""
    <div id=MessageDiv>
      <h1>Gateway Monitor</h1>
      <dl>
        <dt>Current time:</dt>
        <dd>%s</dd>
        <dt>Startup time:</dt>
        <dd>%s</dd>
        <dt>Uptime:</dt>
        <dd>%s</dd>
        <dt>%d active threads:</dt>
        <dd>
          <ul>
            %s
          </ul>
        </dd>
        <dt>%d LDAP connections:</dt>
        <dd>
          <ul>
            %s
          </ul>
        </dd>
        <dt>Time until re-bind is necessary:</dt>
        <dd>%d secs</dd>
        <dt>Time after which sessions are removed:</dt>
        <dd>%d secs</dd>
      </dl>
    </div>
    """ % (
      utctime.strftimeiso8601(time.gmtime(time.time())),
      utctime.strftimeiso8601(time.gmtime(w2lcore.startUpTime)),
      '%02d:%02d' % (uptime/60,uptime%60),
      threading.activeCount(),
      '\n'.join(
        map(
          lambda t:'<li>%s</li>' % ''.join(
            [
              repr(t),
              ', alive'*t.isAlive(),
              ', daemon'*t.isDaemon(),
            ]
          ),
          threading.enumerate()
        )
      ),
      len(w2lcore.session.sessiondict)/2,
      '\n'.join(
        map(
          lambda l:'<li>%s: %s</li>' % (
            utctime.strftimeiso8601(time.gmtime(l[1][0])),escapeHTML(repr(l[1][1]))
          ),
          filter(
            lambda l:not l[0].startswith('__'),
            w2lcore.session.sessiondict.items()
          )
        )
      ),
      web2ldapcnf.session_relogin,
      web2ldapcnf.session_remove,
    )
  )
  w2lgui.PrintFooter(outf)
